# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

from tvtk.tvtk_classes.data_object import DataObject


class AbstractElectronicData(DataObject):
    """
    AbstractElectronicData - Provides access to and storage of
    
    Superclass: DataObject
    
    
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkAbstractElectronicData, obj, update, **traits)
    
    def _get_electron_density(self):
        return wrap_vtk(self._vtk_obj.GetElectronDensity())
    electron_density = traits.Property(_get_electron_density, help=\
        """
        Returns ImageData for the molecule's electron density. The
        data will be calculated when first requested, and cached for
        later requests.
        """
    )

    def _get_homo(self):
        return wrap_vtk(self._vtk_obj.GetHOMO())
    homo = traits.Property(_get_homo, help=\
        """
        Returns ImageData for the Highest Occupied Molecular Orbital.
        """
    )

    def _get_homo_orbital_number(self):
        return self._vtk_obj.GetHOMOOrbitalNumber()
    homo_orbital_number = traits.Property(_get_homo_orbital_number, help=\
        """
        
        """
    )

    def _get_lumo(self):
        return wrap_vtk(self._vtk_obj.GetLUMO())
    lumo = traits.Property(_get_lumo, help=\
        """
        Returns ImageData for the Lowest Unoccupied Molecular Orbital.
        """
    )

    def _get_lumo_orbital_number(self):
        return self._vtk_obj.GetLUMOOrbitalNumber()
    lumo_orbital_number = traits.Property(_get_lumo_orbital_number, help=\
        """
        
        """
    )

    def get_mo(self, *args):
        """
        V.get_mo(int) -> ImageData
        C++: virtual ImageData *GetMO(IdType orbitalNumber)
        Returns the ImageData for the requested molecular orbital.
        """
        ret = self._wrap_call(self._vtk_obj.GetMO, *args)
        return wrap_vtk(ret)

    def _get_number_of_electrons(self):
        return self._vtk_obj.GetNumberOfElectrons()
    number_of_electrons = traits.Property(_get_number_of_electrons, help=\
        """
        Returns the number of electrons in the molecule.
        """
    )

    def _get_number_of_m_os(self):
        return self._vtk_obj.GetNumberOfMOs()
    number_of_m_os = traits.Property(_get_number_of_m_os, help=\
        """
        Returns the number of molecular orbitals available.
        """
    )

    def _get_padding(self):
        return self._vtk_obj.GetPadding()
    padding = traits.Property(_get_padding, help=\
        """
        Get the padding between the molecule and the cube boundaries.
        This is used to determine the dataset's bounds.
        """
    )

    def is_homo(self, *args):
        """
        V.is_homo(int) -> bool
        C++: bool IsHOMO(IdType orbitalNumber)
        Returns true if the given orbital number is the Highest Occupied
        Molecular Orbital, false otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.IsHOMO, *args)
        return ret

    def is_lumo(self, *args):
        """
        V.is_lumo(int) -> bool
        C++: bool IsLUMO(IdType orbitalNumber)
        Returns true if the given orbital number is the Lowest Unoccupied
        Molecular Orbital, false otherwise.
        """
        ret = self._wrap_call(self._vtk_obj.IsLUMO, *args)
        return ret

    _updateable_traits_ = \
    (('whole_bounding_box', 'GetWholeBoundingBox'), ('update_piece',
    'GetUpdatePiece'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('whole_extent', 'GetWholeExtent'),
    ('update_number_of_pieces', 'GetUpdateNumberOfPieces'),
    ('update_ghost_level', 'GetUpdateGhostLevel'), ('update_extent',
    'GetUpdateExtent'), ('debug', 'GetDebug'), ('release_data_flag',
    'GetReleaseDataFlag'), ('global_release_data_flag',
    'GetGlobalReleaseDataFlag'), ('reference_count', 'GetReferenceCount'),
    ('maximum_number_of_pieces', 'GetMaximumNumberOfPieces'),
    ('request_exact_extent', 'GetRequestExactExtent'))
    
    _full_traitnames_list_ = \
    (['debug', 'global_release_data_flag', 'global_warning_display',
    'release_data_flag', 'request_exact_extent',
    'maximum_number_of_pieces', 'update_extent', 'update_ghost_level',
    'update_number_of_pieces', 'update_piece', 'whole_bounding_box',
    'whole_extent'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(AbstractElectronicData, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit AbstractElectronicData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View((['global_release_data_flag', 'request_exact_extent'],
            [], ['maximum_number_of_pieces', 'update_extent',
            'update_ghost_level', 'update_number_of_pieces', 'update_piece',
            'whole_bounding_box', 'whole_extent']),
            title='Edit AbstractElectronicData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit AbstractElectronicData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

