# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui import api as traitsui

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

class Vector(tvtk_base.TVTKBase):
    """
    Vector3 - templated base type for storage of 3d vectors.
    
    Superclass: Tuple[T,Size]
    
    This class is a templated data type for storing and manipulating
    fixed size vectors, which can be used to represent two and three
    dimensional points. The memory layout is a contiguous array of the
    specified type, such that a float[2] can be cast to a Vector2f and
    manipulated. Also a float[6] could be cast and used as a
    Vector2f[3].
    
    
    Provided Types:
    
      Vector[float64,4] => Vector<double, 4>
      Vector[float32,4] => Vector<float, 4>
      Vector[int32,4] => Vector<int, 4>
      Vector[float64,2] => Vector<double, 2>
      Vector[float32,2] => Vector<float, 2>
      Vector[int32,2] => Vector<int, 2>
      Vector[float64,3] => Vector<double, 3>
      Vector[float32,3] => Vector<float, 3>
      Vector[int32,3] => Vector<int, 3>
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkVector, obj, update, **traits)
    
    _updateable_traits_ = \
    ()
    
    _full_traitnames_list_ = \
    ([])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Vector, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            traitsui.View((traitsui.Item("handler._full_traits_list",show_label=False)),
            title='Edit Vector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            traitsui.View(([], [], []),
            title='Edit Vector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            traitsui.View((traitsui.HGroup(traitsui.spring, "handler.view_type", show_border=True), 
            traitsui.Item("handler.info.object", editor = traitsui.InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Vector properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

